const entries = [
  "src/andy.ts",
  "src/metronome.worker.ts",
  "src/noise.processor.ts",
];

if (process.env.NODE_ENV === "development") {
  entries.push("src/tools/index.ts");
}

const buildSettings = {
  entryPoints: entries,
  bundle: true,
  minify: false,
  minifyWhitespace: false,
  sourcemap: true,
  outdir: `dist`,
  plugins: [],
  loader: {},
  define: {
    "process.env.NODE_ENV": `"${process.env.NODE_ENV}"`,
  },
  watch: process.env.NODE_ENV === "development",
};

require("esbuild")
  .build(buildSettings)
  .catch(() => process.exit(1));
