
export type SoundOn = (note: string, time: number, output: AudioNode) => SoundOff;
export type SoundOff = (time?: number) => void;
export const NoOp: SoundOff = () => { }

export type Track = {
  lastFn: Array<Array<SoundOff>>; // 16
  idx: number;
  vol: GainNode;
  pan: PannerNode;
  instrument: SoundOn;
};

export type Tracker = {
  /** track info while the song is running */
  tracks: Array<Track>;
  /** all tracks will send audio output to this node */
  output: AudioNode;
}
